// R_Div.cpp : Diverse Funktionen
// G. TAMM, DF9ZO 2007
//--------------------
#ifndef _R_DIV_H_
  #include "R_DIV.H"
#endif
//-----------------------------------------------------------------------------
#ifdef _DEBUG
 #define new DEBUG_NEW

 #undef THIS_FILE
 static char THIS_FILE[]=__FILE__;
#endif 
//Globals++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TaMsgWin* _TaMsgWin_=0;
//TaInpDlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TaInpDlg::TaInpDlg(CWnd* pParent)
	     :CDialog(TaInpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(TaInpDlg)
	m_strEdit = "";
	//}}AFX_DATA_INIT
}

void TaInpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TaInpDlg)
	DDX_Text(pDX, IDC_TAINPDLG_EDIT, m_strEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(TaInpDlg,CDialog)
	//{{AFX_MSG_MAP(TaInpDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL TaInpDlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 SetWindowText(m_strDlgTitle);
 SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);
 GetDlgItem(IDC_TAINPDLG_STATIC1)->SetWindowText(m_strStatic1);
 GetDlgItem(IDC_TAINPDLG_STATIC2)->SetWindowText(m_strStatic2);
 ((CEdit*)GetDlgItem(IDC_TAINPDLG_EDIT))->SetLimitText(StrLim);
 ((CEdit*)GetDlgItem(IDC_TAINPDLG_EDIT))->SetSel(0,-1);
 GetDlgItem(IDC_TAINPDLG_EDIT)->SetFocus();	
 return FALSE;// return TRUE unless you set the focus to a control
	          // EXCEPTION: OCX Property Pages should return FALSE 
}
//TaStatBar++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TaStatBar::TaStatBar() {}

TaStatBar::~TaStatBar() {}

LRESULT TaStatBar::OnSetText(WPARAM wParam, LPARAM lParam)
{
 int bIgnoreSetText=1;

 if ( !bIgnoreSetText ) return CStatusBar::OnSetText( wParam, lParam );
 return 0; 
/*
void CMainWindow::UpDateStatusBar()
{
 m_wndStatusBar.SetPaneText(0,StatStr);	!!!
}

Die WM_SETTEXT-Nachrichten des Anwendungsgersts werden blockiert, 
bei bIgnoreSetText=1, sonst durchgelassen. 
Die Blockade betrifft nur den ersten Statusleistenabschnitt !!!
*/
}

BEGIN_MESSAGE_MAP(TaStatBar, CStatusBar)
	//{{AFX_MSG_MAP(TaStatBar)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
ON_MESSAGE( WM_SETTEXT,OnSetText)
END_MESSAGE_MAP()
//TaMsgWin+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNCREATE(TaMsgWin, CFrameWnd)

TaMsgWin::TaMsgWin() {}

TaMsgWin::TaMsgWin(CFrameWnd* parent,char* title,char* msgstr)
{
 CFrameWnd();
 paintstr=msgstr;
} 

TaMsgWin::~TaMsgWin() 
{
 _TaMsgWin_=0;
}

BEGIN_MESSAGE_MAP(TaMsgWin, CFrameWnd)
	//{{AFX_MSG_MAP(TaMsgWin)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
void TaMsgWin::OnPaint() 
{
 CPaintDC dc(this);
 CRect rect;
 
 GetClientRect(rect);
 rect.InflateRect(-2,0);
 dc.SetTextAlign(TA_BASELINE | TA_CENTER);
 dc.TextOut(rect.right/2,rect.bottom/2,paintstr);
}
//Funktionen+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int MyInpDlg(CWnd* parent,char* title,char* msg1,char* msg2,
                          char* inp,int lim)
{
 int le;

 TaInpDlg dlg(parent);
 dlg.m_strDlgTitle=title;
 dlg.m_strStatic1=msg1;
 dlg.m_strStatic2=msg2;
 dlg.StrLim=lim;
 le=strlen(inp);if (le > lim) inp[lim]=0;
 dlg.m_strEdit=inp;
 if (dlg.DoModal()==IDOK)
 {
  strcpy(inp,LPCTSTR(dlg.m_strEdit));	 
  return IDOK;
 }else return IDCANCEL;
}

int MyInpDlg(CWnd* parent,CString& title,CString& msg1,CString& msg2,
             CString& inp,int lim)
{
 int le;

 TaInpDlg dlg(parent);
 dlg.m_strDlgTitle=title;
 dlg.m_strStatic1=msg1;
 dlg.m_strStatic2=msg2;
 dlg.StrLim=lim;
 le=inp.GetLength();if (le > lim) inp.Right(le-lim);
 dlg.m_strEdit=inp;
 if (dlg.DoModal()==IDOK)
 {
  inp=dlg.m_strEdit;	 
  return IDOK;
 }else return IDCANCEL;
}
//-----------------------------------------------------------------------------
void MyMsgWin(CFrameWnd* parent,char* title,char* msgstr,
              int delay,int X,int Y,int W,int H)
{
 CRect rect; 
 
 if (_TaMsgWin_ != 0) return;
 rect.left=X;rect.top=Y;rect.right=W;rect.bottom=H; 
 _TaMsgWin_=new TaMsgWin(parent,title,msgstr);
 _TaMsgWin_->Create(NULL,title,WS_OVERLAPPED,rect,parent,NULL,0,NULL);
 _TaMsgWin_->ShowWindow(SW_SHOW);
 VDelay(delay);
 if (_TaMsgWin_ != 0) _TaMsgWin_->DestroyWindow();
 _TaMsgWin_=0;
}
//-----------------------------------------------------------------------------
int MyMsgBox(char *titlestr,char *msgstr,int mode)
{
 int style;
 int res;

 switch (mode)
  {
   case 1: style=MB_OK       | MB_TASKMODAL;break;
   case 2: style=MB_OK		 | MB_ICONINFORMATION | MB_TASKMODAL;break;
   case 3: style=MB_OK    	 | MB_ICONSTOP   	  | MB_TASKMODAL;break;
   case 4: style=MB_OKCANCEL | MB_ICONINFORMATION | MB_TASKMODAL;break;
   case 5: style=MB_YESNO  	 | MB_ICONQUESTION	  | MB_TASKMODAL;break;
   default:style=MB_OK       | MB_TASKMODAL;
  }
 res=MessageBox(AfxGetApp()->GetMainWnd()->m_hWnd,msgstr,titlestr,style);
 return res;
}

int MyMsgBox(CString& titlestr,CString& msgstr,int mode)
{
 int style;
 int res;

 switch (mode)
  {
   case 1: style=MB_OK       | MB_TASKMODAL;break;
   case 2: style=MB_OK		 | MB_ICONINFORMATION | MB_TASKMODAL;break;
   case 3: style=MB_OK    	 | MB_ICONSTOP   	  | MB_TASKMODAL;break;
   case 4: style=MB_OKCANCEL | MB_ICONINFORMATION | MB_TASKMODAL;break;
   case 5: style=MB_YESNO  	 | MB_ICONQUESTION	  | MB_TASKMODAL;break;
   default:style=MB_OK       | MB_TASKMODAL;
  }
 res=MessageBox(AfxGetApp()->GetMainWnd()->m_hWnd,msgstr,titlestr,style);
 return res;
}
//-----------------------------------------------------------------------------
void MyMsgOrBeep(char *titlestr,char *msgstr,int shmsg)
{
 if (shmsg) MessageBox(0,msgstr,titlestr,MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
 	 else MessageBeep(-1);
}
//-----------------------------------------------------------------------------
int CalcRadButtRes(int x0,int x1,int x2,int x3,int x4,
				   int x5,int x6,int x7,int x8,int x9,
                   int x10,int x11,int x12,int x13,int x14,int x15)
{
 int res=0;

 if (x0) res=0;if (x1) res=1;if (x2) res=2;if (x3) res=3;if (x4) res=4;
 if (x5) res=5;if (x6) res=6;if (x7) res=7;if (x8) res=8;if (x9) res=9;
 if (x10) res=10;if (x11) res=11;if (x12) res=12;if (x13) res=13;
 if (x14) res=14;if (x15) res=15;
 return res;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
