// R_DLG.H : Radio-Dlgs
// G. TAMM, DF9ZO 2007
//--------------------
#ifndef _R_DLG_H_
  #include "R_DLG.H"
#endif
//ICOM_BUS_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++
ICOM_BUS_Dlg::ICOM_BUS_Dlg(CWnd* pParent /*=NULL*/)
	         : CDialog(ICOM_BUS_Dlg::IDD, pParent)           
             
{
	//{{AFX_DATA_INIT(ICOM_BUS_Dlg)
	m_icdata  = 0;
	m_filter  = 0;
    m_sql     = 0;
	m_name    = _T("");
	m_icadr   = _T("");
	m_smconv  = _T("");
	m_minf    = _T("");
	m_maxf    = _T("");
	m_deff    = _T("");
	m_ssb_no  = _T("");
	m_ssb_na  = _T("");
	m_ssb_wi  = _T("");
	m_fm_no   = _T("");
	m_fm_na   = _T("");
	m_fm_wi   = _T("");
	m_fmw_no  = _T("");
	m_fmw_na  = _T("");
	m_fmw_wi  = _T("");
	m_am_no   = _T("");
	m_am_na   = _T("");
	m_am_wi   = _T("");
	m_cw_no   = _T("");
	m_cw_na   = _T("");
	m_cw_wi   = _T("");
	m_rtty_no = _T("");
	m_rtty_na = _T("");
	m_rtty_wi = _T("");
	//}}AFX_DATA_INIT
}

void ICOM_BUS_Dlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(ICOM_BUS_Dlg)
    DDX_Radio(pDX, IDC_ICOM_BUS_BU_DA0,  m_icdata);
    DDX_Radio(pDX, IDC_ICOM_BUS_BU_FI0,  m_filter);
    DDX_Radio(pDX, IDC_ICOM_BUS_RB_SQL0, m_sql);
    DDX_Text(pDX, IDC_ICOM_BUS_ED01,    m_name);
    DDV_MaxChars(pDX, m_name, 49);
    DDX_Text(pDX, IDC_ICOM_BUS_ED02,    m_icadr);
    DDV_MaxChars(pDX, m_icadr, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED03,    m_smconv);
    DDV_MaxChars(pDX, m_smconv, 19);
    DDX_Text(pDX, IDC_ICOM_BUS_ED04,    m_minf);
    DDV_MaxChars(pDX, m_minf, 12);
    DDX_Text(pDX, IDC_ICOM_BUS_ED05,    m_maxf);
    DDV_MaxChars(pDX, m_maxf, 12);
    DDX_Text(pDX, IDC_ICOM_BUS_ED06,    m_deff);
    DDV_MaxChars(pDX, m_deff, 12);
    DDX_Text(pDX, IDC_ICOM_BUS_ED10,    m_ssb_no);
    DDV_MaxChars(pDX, m_ssb_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED11,    m_ssb_na);
    DDV_MaxChars(pDX, m_ssb_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED12,    m_ssb_wi);
    DDV_MaxChars(pDX, m_ssb_wi, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED13,    m_fm_no);
    DDV_MaxChars(pDX, m_fm_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED14,    m_fm_na);
    DDV_MaxChars(pDX, m_fm_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED15,    m_fm_wi);
    DDV_MaxChars(pDX, m_fm_wi, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED16,    m_fmw_no);
    DDV_MaxChars(pDX, m_fmw_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED17,    m_fmw_na);
    DDV_MaxChars(pDX, m_fmw_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED18,    m_fmw_wi);
    DDV_MaxChars(pDX, m_fmw_wi, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED19,    m_am_no);
    DDV_MaxChars(pDX, m_am_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED20,    m_am_na);
    DDV_MaxChars(pDX, m_am_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED21,    m_am_wi);
    DDV_MaxChars(pDX, m_am_wi, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED22,    m_cw_no);
    DDV_MaxChars(pDX, m_cw_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED23,    m_cw_na);
    DDV_MaxChars(pDX, m_cw_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED24,    m_cw_wi);
    DDV_MaxChars(pDX, m_cw_wi, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED25,    m_rtty_no);
    DDV_MaxChars(pDX, m_rtty_no, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED26,    m_rtty_na);
    DDV_MaxChars(pDX, m_rtty_na, 2);
    DDX_Text(pDX, IDC_ICOM_BUS_ED27,    m_rtty_wi);
    DDV_MaxChars(pDX, m_rtty_wi, 2);
    //}}AFX_DATA_MAP
    }

BEGIN_MESSAGE_MAP(ICOM_BUS_Dlg, CDialog)
	//{{AFX_MSG_MAP(ICOM_BUS_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL ICOM_BUS_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control 
}

void ICOM_BUS_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;
	
 CDialog::OnOK();
}
//-----------------------------------------------------------------------------
void ICOM_BUS_Dlg::TransferToDlg(int radio)
{
 if (IRADIO_IB[radio].IB_Da_n   == 4) m_icdata=0;else m_icdata=1;
 if (IRADIO_IB[radio].IB_DSP_Fi == 0) m_filter=1;else m_filter=0;
 if (IRADIO_IB[radio].SQL_SH    == 0) m_sql   =0;else m_sql   =1;
 m_name  =IRADIO_IB[radio].Name;
 m_icadr =IRADIO_IB[radio].IB_Adr_s;
 m_smconv=IRADIO_IB[radio].SmConv_s;
 m_minf  =IRADIO_IB[radio].Fmin_s;
 m_maxf  =IRADIO_IB[radio].Fmax_s;
 m_deff  =IRADIO_IB[radio].Fdef_s;
 //---------------------------
 m_ssb_no =IRADIO_IB[radio].IB_Fi_s[ 0];
 m_ssb_na =IRADIO_IB[radio].IB_Fi_s[ 1];
 m_ssb_wi =IRADIO_IB[radio].IB_Fi_s[ 2];
 m_fm_no  =IRADIO_IB[radio].IB_Fi_s[ 3];
 m_fm_na  =IRADIO_IB[radio].IB_Fi_s[ 4];
 m_fm_wi  =IRADIO_IB[radio].IB_Fi_s[ 5];
 m_fmw_no =IRADIO_IB[radio].IB_Fi_s[ 6];
 m_fmw_na =IRADIO_IB[radio].IB_Fi_s[ 7];
 m_fmw_wi =IRADIO_IB[radio].IB_Fi_s[ 8];
 m_am_no  =IRADIO_IB[radio].IB_Fi_s[ 9];
 m_am_na  =IRADIO_IB[radio].IB_Fi_s[10];
 m_am_wi  =IRADIO_IB[radio].IB_Fi_s[11];
 m_cw_no  =IRADIO_IB[radio].IB_Fi_s[12];
 m_cw_na  =IRADIO_IB[radio].IB_Fi_s[13];
 m_cw_wi  =IRADIO_IB[radio].IB_Fi_s[14];
 m_rtty_no=IRADIO_IB[radio].IB_Fi_s[15];
 m_rtty_na=IRADIO_IB[radio].IB_Fi_s[16];
 m_rtty_wi=IRADIO_IB[radio].IB_Fi_s[17];
}

void ICOM_BUS_Dlg::TransferFrDlg(int radio)
{
 if (m_icdata == 0) IRADIO_IB[radio].IB_Da_n  =4;else IRADIO_IB[radio].IB_Da_n  =5;
 if (m_filter == 0) IRADIO_IB[radio].IB_DSP_Fi=1;else IRADIO_IB[radio].IB_DSP_Fi=0;
 if (m_sql    == 0) IRADIO_IB[radio].SQL_SH   =0;else IRADIO_IB[radio].SQL_SH   =1;
 strcpy(IRADIO_IB[radio].Name,LPCTSTR(m_name));
 strcpy(IRADIO_IB[radio].IB_Adr_s,LPCTSTR(m_icadr));
 strcpy(IRADIO_IB[radio].SmConv_s,LPCTSTR(m_smconv));
 strcpy(IRADIO_IB[radio].Fmin_s,LPCTSTR(m_minf));
 strcpy(IRADIO_IB[radio].Fmax_s,LPCTSTR(m_maxf));
 strcpy(IRADIO_IB[radio].Fdef_s,LPCTSTR(m_deff));
 //------------------------------------------
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 0],LPCTSTR(m_ssb_no));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 1],LPCTSTR(m_ssb_na));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 2],LPCTSTR(m_ssb_wi));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 3],LPCTSTR(m_fm_no ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 4],LPCTSTR(m_fm_na ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 5],LPCTSTR(m_fm_wi ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 6],LPCTSTR(m_fmw_no));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 7],LPCTSTR(m_fmw_na));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 8],LPCTSTR(m_fmw_wi));
 strcpy(IRADIO_IB[radio].IB_Fi_s[ 9],LPCTSTR(m_am_no ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[10],LPCTSTR(m_am_na ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[11],LPCTSTR(m_am_wi ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[12],LPCTSTR(m_cw_no ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[13],LPCTSTR(m_cw_na ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[14],LPCTSTR(m_cw_wi ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[15],LPCTSTR(m_rtty_no ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[16],LPCTSTR(m_rtty_na ));
 strcpy(IRADIO_IB[radio].IB_Fi_s[17],LPCTSTR(m_rtty_wi ));
}
//FSTEPSW_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FSTEPSW_Dlg::FSTEPSW_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(FSTEPSW_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(FSTEPSW_Dlg)
	m_Combo = _T("");
	//}}AFX_DATA_INIT
}

void FSTEPSW_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FSTEPSW_Dlg)
	DDX_CBString(pDX, IDC_FSTEPSW_COMBO, m_Combo);
	DDV_MaxChars(pDX, m_Combo, 12);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(FSTEPSW_Dlg, CDialog)
	//{{AFX_MSG_MAP(FSTEPSW_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
void FSTEPSW_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;
  
 CDialog::OnOK();
}

BOOL FSTEPSW_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control 
}
//FSTEPHW_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FSTEPHW_Dlg::FSTEPHW_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(FSTEPHW_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(FSTEPHW_Dlg)
	m_list = -1;
	//}}AFX_DATA_INIT
}

void FSTEPHW_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FSTEPHW_Dlg)
	DDX_LBIndex(pDX, IDC_FSTEPHW_LIST, m_list);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(FSTEPHW_Dlg, CDialog)
	//{{AFX_MSG_MAP(FSTEPHW_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
void FSTEPHW_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;

 CDialog::OnOK();
}

BOOL FSTEPHW_Dlg::OnInitDialog() 
{
 CListBox* pLB;

 CDialog::OnInitDialog();
 //SetIcon(::LoadIcon(AfxGetApp()->m_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME)),TRUE);
 pLB=(CListBox*) GetDlgItem(IDC_FSTEPHW_LIST);
 //pLB->AddString("1 Hz");
 pLB->AddString("10 Hz");
 pLB->AddString("100 Hz");
 pLB->AddString("1 kHz");
 pLB->AddString("5 kHz");
 pLB->AddString("9 kHz");
 pLB->AddString("10 kHz");
 pLB->AddString("12.5 kHz");
 pLB->AddString("20 kHz");
 pLB->AddString("25 kHz");
 pLB->AddString("100 kHz");
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control 
}
//FOFFSET_Dlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FOFFSET_Dlg::FOFFSET_Dlg(CWnd* pParent /*=NULL*/)
	        : CDialog(FOFFSET_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(FOFFSET_Dlg)
	m_Combo = _T("");
	//}}AFX_DATA_INIT
}

void FOFFSET_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(FOFFSET_Dlg)
	DDX_CBString(pDX, IDC_FOFFSET_COMBO1, m_Combo);
	DDV_MaxChars(pDX, m_Combo, 12);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(FOFFSET_Dlg, CDialog)
	//{{AFX_MSG_MAP(FOFFSET_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL FOFFSET_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}

void FOFFSET_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;
	
 CDialog::OnOK();
}
//MODE_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
MODE_Dlg::MODE_Dlg(CWnd* pParent /*=NULL*/)
	     : CDialog(MODE_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(MODE_Dlg)
	m_mode   = 0;
	m_filter = 0;
	//}}AFX_DATA_INIT
}

void MODE_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MODE_Dlg)
	DDX_Radio(pDX, IDC_MODE_RB00, m_mode);
	DDX_Radio(pDX, IDC_MODE_RB10, m_filter);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(MODE_Dlg, CDialog)
	//{{AFX_MSG_MAP(MODE_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL MODE_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}

void MODE_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;

 CDialog::OnOK();
}
//RTTY_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNAMIC(RTTY_Dlg, CDialog)
RTTY_Dlg::RTTY_Dlg(CWnd* pParent /*=NULL*/)
	     :CDialog(RTTY_Dlg::IDD, pParent)
         , m_MF(0)
         , m_SH(0)
         , m_KP(0)
         , m_RXDEC(0)
         , m_TPF(0)
{
}

RTTY_Dlg::~RTTY_Dlg()
{
}

void RTTY_Dlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);

    DDX_Radio(pDX, IDC_RTTY_MF_RB0,    m_MF);
    DDX_Radio(pDX, IDC_RTTY_SH_RB0,    m_SH);
    DDX_Radio(pDX, IDC_RTTY_KP_RB0,    m_KP);
    DDX_Radio(pDX, IDC_RTTY_RXDEC_RB0, m_RXDEC);
    DDX_Radio(pDX, IDC_RTTY_TPF_RB0,   m_TPF);
}

BEGIN_MESSAGE_MAP(RTTY_Dlg, CDialog)
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL RTTY_Dlg::OnInitDialog()
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}
//CLRMEM_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++
CLRMEM_Dlg::CLRMEM_Dlg(CWnd* pParent /*=NULL*/)
	       : CDialog(CLRMEM_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLRMEM_Dlg)
	m_from = _T("");
	m_to = _T("");
	//}}AFX_DATA_INIT
}

void CLRMEM_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLRMEM_Dlg)
	DDX_Text(pDX, IDC_CLRMEM_ED00, m_from);
	DDV_MaxChars(pDX, m_from, 3);
	DDX_Text(pDX, IDC_CLRMEM_ED01, m_to);
	DDV_MaxChars(pDX, m_to, 3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLRMEM_Dlg, CDialog)
	//{{AFX_MSG_MAP(CLRMEM_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
void CLRMEM_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;
	
 CDialog::OnOK();
}

BOOL CLRMEM_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}
//MEMBANK_Dlg ICOM CI-V - Bus++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNAMIC(MEMBANK_Dlg, CDialog)
MEMBANK_Dlg::MEMBANK_Dlg(CWnd* pParent /*=NULL*/)
	        : CDialog(MEMBANK_Dlg::IDD, pParent)           
            , m_bank(0)
{
}

MEMBANK_Dlg::~MEMBANK_Dlg()
{
}

void MEMBANK_Dlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);

    DDX_Radio(pDX, IDC_MEMBANK_RB01, m_bank);
}

BEGIN_MESSAGE_MAP(MEMBANK_Dlg, CDialog)
END_MESSAGE_MAP()
//MEMCMD_Dlg ICOM CI-V - Bus+++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNAMIC(MEMCMD_Dlg, CDialog)
MEMCMD_Dlg::MEMCMD_Dlg(CWnd* pParent /*=NULL*/)
	       : CDialog(MEMCMD_Dlg::IDD, pParent)
           , m_cmd(0)
{
}

MEMCMD_Dlg::~MEMCMD_Dlg()
{
}

void MEMCMD_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Radio(pDX, IDC_MEMCMD_RB1, m_cmd);
}

BEGIN_MESSAGE_MAP(MEMCMD_Dlg, CDialog)
END_MESSAGE_MAP()
//STOPMODE_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
STOPMODE_Dlg::STOPMODE_Dlg(CWnd* pParent /*=NULL*/)
	         : CDialog(STOPMODE_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(STOPMODE_Dlg)
	m_mo = -1;
	m_ed00 = _T("");
	m_ed01 = _T("");
	//}}AFX_DATA_INIT
}

void STOPMODE_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(STOPMODE_Dlg)
	DDX_Radio(pDX, IDC_STOPMODE_BU00, m_mo);
	DDX_Text(pDX, IDC_STOPMODE_ED00, m_ed00);
	DDV_MaxChars(pDX, m_ed00, 5);
	DDX_Text(pDX, IDC_STOPMODE_ED01, m_ed01);
	DDV_MaxChars(pDX, m_ed01, 5);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(STOPMODE_Dlg, CDialog)
	//{{AFX_MSG_MAP(STOPMODE_Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//-----------------------------------------------------------------------------
BOOL STOPMODE_Dlg::OnInitDialog() 
{
 CDialog::OnInitDialog();
 GetDlgItem(IDOK)->SetFocus();
 return FALSE;// return TRUE unless you set the focus to a control
}

void STOPMODE_Dlg::OnOK() 
{
 if (!UpdateData(TRUE)) return;
	
 CDialog::OnOK();
}
//ICOM_OPTIONS_Dlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNAMIC(ICOM_OPTIONS_Dlg, CDialog)
ICOM_OPTIONS_Dlg::ICOM_OPTIONS_Dlg(CWnd* pParent /*=NULL*/)
	             : CDialog(ICOM_OPTIONS_Dlg::IDD, pParent)
                 , m_SM_sel(0)
                 , m_SQLSM_cont(0)
                 , m_conf(0)
                 , m_delay(_T(""))
{
}

ICOM_OPTIONS_Dlg::~ICOM_OPTIONS_Dlg()
{
}

void ICOM_OPTIONS_Dlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Radio(pDX, IDC_ICOM_OPTIONS_RB1, m_SM_sel);
    DDX_Radio(pDX, IDC_ICOM_OPTIONS_RB3, m_SQLSM_cont);
    DDX_Check(pDX, IDC_ICOM_OPTIONS_CB1, m_conf);
    DDX_Text(pDX, IDC_ICOM_OPTIONS_ED1,  m_delay);
	DDV_MaxChars(pDX, m_delay, 4);
}

BEGIN_MESSAGE_MAP(ICOM_OPTIONS_Dlg, CDialog)
END_MESSAGE_MAP()
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
